ALTER TABLE Trn_OilDespClieProd ADD IndMezcla INT DEFAULT(0) NOT NULL,ItemMezcla INT DEFAULT(0) NOT NULL,FactorMezcla DECIMAL(16,6) DEFAULT(0) NOT NULL
GO
INSERT INTO adm_Opciones (IdOpc,Opcion,TipoDato,Valor,NivUp,nModulo)
 VALUES ('ETI','HABILITAR EDICION DE NOTAS DE TRASLADO DE INVENTARIO','BOOLEAN','0',5,'MAIN')
GO
INSERT INTO Sys_ObjetosApp (IdObj,IdGrupo,SubModulo,IndObj,Nombre,Formulario,Permisos,NivelMinimo,NomArchivo)
 VALUES ('FRMDTCP','OILDOC','GEN',13,'Nota de Traslado de Inventarios','FRMDTCP','SSSSSSSSSSSSS',0,'')
GO
INSERT INTO Sys_Roles (IdObj,IdRole,Funcion)
 VALUES ('FRMDTCP','ADC','Modificar o Anular documento creado en otra compañía')
INSERT INTO Sys_Roles (IdObj,IdRole,Funcion)
 VALUES ('FRMDTCP','COS','Permitir editar Costo Unitario')
INSERT INTO Sys_Roles (IdObj,IdRole,Funcion)
 VALUES ('FRMDTCP','DET','Permitir editar detalle de costos')
INSERT INTO Sys_Roles (IdObj,IdRole,Funcion)
 VALUES ('FRMDTCP','FEC','Habilitar Fecha Abierta')
INSERT INTO Sys_Roles (IdObj,IdRole,Funcion)
 VALUES ('FRMDTCP','MOD','Modificar Documento')
INSERT INTO Sys_Roles (IdObj,IdRole,Funcion)
 VALUES ('FRMDTCP','NIT','Permitir cambiar Nit del tercero')
INSERT INTO Sys_Roles (IdObj,IdRole,Funcion)
 VALUES ('FRMDTCP','UND','Permitir seleccionar Unidad de Medida')
INSERT INTO Sys_Roles (IdObj,IdRole,Funcion)
 VALUES ('FRMDTCP','CIE','Permitir período abierto')
GO
CREATE TABLE Trn_OilTraslado ( 
TipDoc VARCHAR(3) NOT NULL,
NumNota INT DEFAULT ((0)) NOT NULL,
IdCia CHAR(2) NOT NULL,
Fecha SMALLDATETIME NOT NULL,
FechaInicio SMALLDATETIME NOT NULL,
FechaFinal SMALLDATETIME NOT NULL,
IdConcepto VARCHAR(4) NOT NULL,
IdTercero VARCHAR(16) NOT NULL,
CantMP DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CantProducido DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CantConsumo DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CantCrudoCom DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
Total_MP DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
VU_MP DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CantBrutoMP DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CantNetoMP DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CantFactMP DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
Total_TRA DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
VU_TRA DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CantNetoTRA DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CantFactTRA DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
Total_TVacio DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
VU_TVacio DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CantNetoTv DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CantFactTv DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
Total_Standby DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
VU_Standby DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
Cant_Standby DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
Total_MOD DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
Total_CIF DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CdCCosto VARCHAR(16),
CdSubCos VARCHAR(16),
TipCom VARCHAR(3),
Comprobante INT DEFAULT ((0)) NOT NULL,
IdCiaCom CHAR(2) NOT NULL,
Anulado BIT DEFAULT ((0)) NOT NULL,
NumDev INT DEFAULT ((0)) NOT NULL,
FecDev SMALLDATETIME,
Observacion VARCHAR(2000),
IdEstado VARCHAR(4) NOT NULL,
FechaCrea SMALLDATETIME NOT NULL,
IdCiaCrea CHAR(2) NOT NULL,
OrigenAdd VARCHAR(10) NOT NULL,
IdUsuario VARCHAR(11) NOT NULL
 CONSTRAINT PK_Trn_OilTraslado PRIMARY KEY CLUSTERED (TipDoc,NumNota,IdCia),
 CONSTRAINT CK_Trn_OilTrasladoIdCia CHECK ((len([IdCia])>(0))),
 CONSTRAINT CK_Trn_OilTrasladoIdCiaCom CHECK ((len([IdCiaCom])>(0))),
 CONSTRAINT CK_Trn_OilTrasladoIdCiaCrea CHECK ((len([IdCiaCrea])>(0))),
 CONSTRAINT CK_Trn_OilTrasladoIdConcepto CHECK ((len([IdConcepto])>(0))),
 CONSTRAINT CK_Trn_OilTrasladoIdEstado CHECK ((len([IdEstado])>(0))),
 CONSTRAINT CK_Trn_OilTrasladoIdTercero CHECK ((len([IdTercero])>(0))),
 CONSTRAINT CK_Trn_OilTrasladoIdUsuario CHECK ((len([IdUsuario])>(0))),
 CONSTRAINT CK_Trn_OilTrasladoOrigenAdd CHECK ((len([OrigenAdd])>(0))),
 CONSTRAINT CK_Trn_OilTrasladoTipDoc CHECK ((len([TipDoc])>(0))))
CREATE TABLE Trn_OilTrasladoProd ( 
TipDoc VARCHAR(3) NOT NULL,
NumNota INT DEFAULT ((0)) NOT NULL,
IdCia CHAR(2) NOT NULL,
Item INT DEFAULT ((0)) NOT NULL,
IdProducto VARCHAR(16) NOT NULL,
Descripcion VARCHAR(500) NOT NULL,
TipoProd VARCHAR(10) NOT NULL,
SaldoInicial DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
SaldoFinal DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
Entradas DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
Despachos DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
DespMezcla DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
Salidas DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
AjuSobrante DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
AjuFaltante DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
Cantidad DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
UndMed VARCHAR(10) DEFAULT ('br') NOT NULL,
PorcRend DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CostoAnt DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
VrUnitario DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
VrTotal DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
SaldoMPAnt DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CantProdAnt DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CostoMPAnt DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CostoMPMes DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CostoUndMP DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CostoUndTra DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CostoTotalTra DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CostoTotalSB DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CostoUndVco DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CostoTotalVco DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CostoTotalMod DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CostoTotalCif DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CodMezcla VARCHAR(16),
CdoSubMezcla VARCHAR(8)
 CONSTRAINT PK_Trn_OilTrasladoProd PRIMARY KEY CLUSTERED (TipDoc,NumNota,IdCia,Item),
 CONSTRAINT CK_Trn_OilTrasladoProdDescripcion CHECK ((len([Descripcion])>(0))),
 CONSTRAINT CK_Trn_OilTrasladoProdIdCia CHECK ((len([IdCia])>(0))),
 CONSTRAINT CK_Trn_OilTrasladoProdIdProducto CHECK ((len([IdProducto])>(0))),
 CONSTRAINT CK_Trn_OilTrasladoProdTipDoc CHECK ((len([TipDoc])>(0))),
 CONSTRAINT CK_Trn_OilTrasladoProdTipoProd CHECK ((len([TipoProd])>(0))),
 CONSTRAINT CK_Trn_OilTrasladoProdUndMed CHECK ((len([UndMed])>(0))))
CREATE TABLE Trn_OilTrasladoRubros ( 
TipDoc VARCHAR(3) NOT NULL,
NumNota INT DEFAULT ((0)) NOT NULL,
IdCia CHAR(2) NOT NULL,
Item INT DEFAULT ((0)) NOT NULL,
IdProducto VARCHAR(16) NOT NULL,
TipoRubro VARCHAR(10) NOT NULL,
CantBruto DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
CantNeto DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
Cantidad DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
VrUnitario DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
VrTotal DECIMAL(16,6) DEFAULT ((0)) NOT NULL,
UndMed VARCHAR(10) DEFAULT ('br') NOT NULL,
CodCueCP VARCHAR(16)
 CONSTRAINT PK_Trn_OilTrasladoRubros PRIMARY KEY CLUSTERED (TipDoc,NumNota,IdCia,Item),
 CONSTRAINT CK_Trn_OilTrasladoRubrosIdCia CHECK ((len([IdCia])>(0))),
 CONSTRAINT CK_Trn_OilTrasladoRubrosIdProducto CHECK ((len([IdProducto])>(0))),
 CONSTRAINT CK_Trn_OilTrasladoRubrosTipDoc CHECK ((len([TipDoc])>(0))),
 CONSTRAINT CK_Trn_OilTrasladoRubrosTipoRubro CHECK ((len([TipoRubro])>(0))),
 CONSTRAINT CK_Trn_OilTrasladoRubrosUndMed CHECK ((len([UndMed])>(0))))
GO
ALTER TABLE Trn_OilTraslado ADD 
 CONSTRAINT FK_Trn_OilTraslado_adm_Usuarios FOREIGN KEY (IdUsuario) REFERENCES [dbo].[adm_Usuarios] (IdUsuario),
 CONSTRAINT FK_Trn_OilTraslado_Companias FOREIGN KEY (IdCia) REFERENCES [dbo].[Companias] (IdCia),
 CONSTRAINT FK_Trn_OilTraslado_Companias1 FOREIGN KEY (IdCiaCrea) REFERENCES [dbo].[Companias] (IdCia),
 CONSTRAINT FK_Trn_OilTraslado_Conceptos FOREIGN KEY (IdConcepto) REFERENCES [dbo].[Conceptos] (IdConcepto),
 CONSTRAINT FK_Trn_OilTraslado_EstadoDoc FOREIGN KEY (IdEstado) REFERENCES [dbo].[EstadoDoc] (IdEstado),
 CONSTRAINT FK_Trn_OilTraslado_Sys_TiposDoc FOREIGN KEY (TipDoc) REFERENCES [dbo].[Sys_TiposDoc] (IdDoc),
 CONSTRAINT FK_Trn_OilTraslado_Terceros FOREIGN KEY (IdTercero) REFERENCES [dbo].[Terceros] (IdTercero)
 
 CREATE NONCLUSTERED INDEX IX_Trn_OilTrasladoFecha ON Trn_OilTraslado(Fecha)
 CREATE NONCLUSTERED INDEX IX_Trn_OilTrasladoFechaInicio ON Trn_OilTraslado(FechaInicio,FechaFinal)
 CREATE NONCLUSTERED INDEX IX_Trn_OilTrasladoIdTercero ON Trn_OilTraslado(IdTercero)

ALTER TABLE Trn_OilTrasladoProd ADD 
 CONSTRAINT FK_Trn_OilTrasladoProd_ProdMcias FOREIGN KEY (IdProducto) REFERENCES [dbo].[ProdMcias] (IdProducto),
 CONSTRAINT FK_Trn_OilTrasladoProd_Sys_Um FOREIGN KEY (UndMed) REFERENCES [dbo].[Sys_Um] (UndMed),
 CONSTRAINT FK_Trn_OilTrasladoProd_Trn_OilTraslado FOREIGN KEY (TipDoc,NumNota,IdCia) REFERENCES [dbo].[Trn_OilTraslado] (TipDoc,NumNota,IdCia)

 CREATE NONCLUSTERED INDEX IX_Trn_OilTrasladoProdIdProducto ON Trn_OilTrasladoProd(IdProducto)

ALTER TABLE Trn_OilTrasladoRubros ADD 
 CONSTRAINT FK_Trn_OilTrasladoRubros_ProdMcias FOREIGN KEY (IdProducto) REFERENCES [dbo].[ProdMcias] (IdProducto),
 CONSTRAINT FK_Trn_OilTrasladoRubros_Sys_Um FOREIGN KEY (UndMed) REFERENCES [dbo].[Sys_Um] (UndMed),
 CONSTRAINT FK_Trn_OilTrasladoRubros_Trn_OilTraslado FOREIGN KEY (TipDoc,NumNota,IdCia) REFERENCES [dbo].[Trn_OilTraslado] (TipDoc,NumNota,IdCia)
